# mode: run
# distutils: language=c++
# distutils: extra_compile_args=-std=c++11
# tag: cpp

cdef cypclass SomeMemory:
  int a
  void __init__(self, int a):
    this.a = a
  void __init__(self, int a, int b):
    this.a = a*b

cdef cypclass SomeSubMemory(SomeMemory):

  void __init__(self, int a, int b):
    this.a = a+b

  int getter(self):
    return this.a

cpdef foo():
  cdef SomeMemory o1 = SomeMemory(2, 7)
  return o1.a

cpdef bar():
  cdef SomeSubMemory o2 = SomeSubMemory(2, 7)
  return o2.getter()

cpdef baz():
  cdef SomeSubMemory o3 = SomeSubMemory(2)
  return o3.getter()

def bag():
  """
  >>> bag()
  14
  9
  2
  """
  print str(foo()) + '\n' + str(bar()) + '\n' + str(baz())
