# mode: run
# distutils: language=c++
# distutils: extra_compile_args=-std=c++11
# tag: cpp

cdef cypclass SomeMemory[T, U]:
  T a
  U b
  void __init__(self, T a, U b):
    self.a = a
    self.b = b

  T first(self):
    return self.a

  U second(self):
    return self.b

cpdef bag():
  """
  >>> bag()
  1
  2.3
  1
  2.3
  """
  cdef SomeMemory[int, double] o = SomeMemory[int, double](1, 2.3)
  cdef SomeMemory[int, int] b = new SomeMemory[int, int]()
  del b
  print str(o.a) + '\n' + str(o.b) + '\n' + str(o.first()) + '\n' + str(o.second())
