# mode: run
# distutils: language=c++
# distutils: extra_compile_args=-std=c++11
# tag: cpp

cdef cypclass SomeMemory:
    int a

    void __init__(self, int a=0):
        self.a = a

    SomeMemory __add__(self, SomeMemory other):
        return SomeMemory(self.a + other.a)

    SomeMemory __iadd__(self, SomeMemory other):
        self.a += other.a

    SomeMemory __mul__(self, SomeMemory other):
        return SomeMemory(self.a * other.a)

cdef cypclass SomeSubMemory(SomeMemory):
    int b

cpdef bag():
    """
    >>> bag()
    28
    4
    7
    """
    o1 = SomeMemory()
    o2 = SomeMemory(4)
    o3 = SomeSubMemory(3)

    o3 += o2
    o1 = o2 * o3
    print str(o1.a) + '\n' + str(o2.a) + '\n' + str(o3.a)
