cdef cypclass Base:
    double value

    __init__(self, int a):
        self.value = (<double> a)*1.2

    __init__(self, double b):
        self.value = b

    Base __new__(alloc, int a):
        obj = alloc()
        # After the return, the call Base.__init__(obj, a) will be issued
        return obj

cdef cypclass Derived(Base):
    Derived __new__(alloc, double b):
        obj = alloc()
        # After the return, the call Base.__init__(obj, b) will be issued
        return obj

cpdef void test():
    base = Base(5)
    derived = Derived(5)
    # Should print: 6 5
    print(base.value, derived.value)

